(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



XAxis = {1,0,0};
YAxis = {0,1,0};
ZAxis = {0,0,1};


Inv[u_] := Tan[u]-u;


Pinion[pitchradius_?NumericQ, toothcount_?IntegerQ, alpha_?NumericQ];
Pinion/:MakeBoxes[Pinion[pitchradius_?NumericQ, toothcount_?IntegerQ, alpha_?NumericQ],StandardForm]:=ToBoxes[Pinion["..."]]

Gear[shaper_Pinion, gamma_?NumericQ, ratio_?NumericQ];
Gear/:MakeBoxes[Gear[shaper_Pinion, gamma_?NumericQ, ratio_?NumericQ],StandardForm]:=ToBoxes[Gear["..."]]

Gearset[gear_Gear, pinion_Pinion, gamma_?NumericQ, positions_List, angles_List];
Gearset/:MakeBoxes[Gearset[gear_Gear, pinion_Pinion, gamma_?NumericQ, positions_List, angles_List],StandardForm]:=ToBoxes[Gearset["..."]]


FGPinionSurfaceFunction[pinion_Pinion] :=
    Module[ {InvoluteCurveFunction, epsilon, rp, rb, ns, alpha, P, ra, thetamax},
rp = pinion[[1]];
rb = rp*Cos[alpha];
ns = pinion[[2]];
alpha = pinion[[3]];
P = ns/(2 rp);
ra = rp + 1/P;
thetamax = Sqrt[ra^2 - rb^2]/rb;
epsilon = Pi/(2 ns)-Inv[alpha];
InvoluteCurveFunction = 
Function[{theta},
Composition[
RotationTransform[-epsilon,ZAxis],
RotationTransform[-theta,ZAxis],
TranslationTransform[{-rb*theta,0,0}],
TranslationTransform[{0,rb,0}]]
];
Function[{theta,z},
InvoluteCurveFunction[theta][{0,0,z}]
]
]


FGInvoluteParameterLimits[pinion_Pinion] :=
Module[ {rp, ns, alpha, rb, P, ra, thetamax},
rp = pinion[[1]];
ns = pinion[[2]];
alpha = pinion[[3]];
rb = rp*Cos[alpha];
P = ns/(2 rp);
ra = rp + 1/P;
thetamax = Sqrt[ra^2 - rb^2]/rb;
{0,thetamax}
]


FGRotationParameterLimits[pinion_Pinion] :=
Module[ {ns},
ns = pinion[[2]];
{-3Pi/ns,3Pi/ns}
]


Magnitude[u_] := Sqrt[ u.u ]


FGGearSurfaceFunction[gear_Gear] :=
Block[ {pinion, gamma, Rs, ns, m, Tsf, T2f, T2s, Ts2, vrs, omega, F, G,z},
pinion = gear[[1]];
gamma = gear[[2]];
m = gear[[3]];
Tsf = Function[{phi},
Composition[RotationTransform[phi,ZAxis],RotationTransform[gamma,XAxis]]
];
T2f = Function[{phi},
RotationTransform[m*phi,ZAxis]
];
T2s = Function[{phi},
Composition[T2f[phi], InverseFunction[Tsf[phi]]]
];
Ts2 = Function[{phi},
Composition[Tsf[phi], InverseFunction[T2f[phi]]]
];
Rs = FGPinionSurfaceFunction[pinion];
ns = Function[{theta},
Block[ {normal, assumptions},
normal = Cross[D[Rs[theta, z], theta], D[Rs[theta, z], z]];
assumptions = (theta \[Element] Reals) && (theta > 0);
Simplify[normal/Magnitude[normal], assumptions]
]
];
vrs = Function[{theta,phi},
Cross[ ( {0,0,omega} - Ts2[phi][{0,0,m*omega}] ), Rs[theta,z] ]
];
F = Function[{theta,phi},
vrs[theta,phi].ns[theta] == 0
];
G = Function[{theta,phi},
Chop@Flatten@Solve[F[theta,phi], z] (* Simplify[] ? *)
];
Function[{theta,phi},
Evaluate[
T2s[phi][Rs[theta,z]/.G[theta,phi]]
]
]
]


FGCriticalPoint[gear_Gear] :=
Block[ {pinion,thetamin, thetamax, theta,phi,R2, n2, phicrit},
pinion=gear[[1]];
{thetamin,thetamax} = FGInvoluteParameterLimits[pinion];
R2 = FGGearSurfaceFunction[gear];
n2 = Cross[ D[R2[theta,phi],theta], D[R2[theta,phi],phi] ] /. {theta -> thetamax};
phicrit = phi /. FindRoot[ Total[n2] == 0, {phi,-0.4}];
R2[theta,phi] /. {phi->phicrit, theta->thetamax}
]


FGConformingPinion[shaper_Pinion,toothcount_?IntegerQ]:=
Block[{rps,ns,alpha,P,rp1},
rps=shaper[[1]];
ns=shaper[[2]];
alpha=shaper[[3]];
P=ns/(2rps);
rp1=toothcount/(2P);
Pinion[rp1,toothcount,alpha]
]


FGContactPath[gearset_Gearset] :=
Module[ {pinion,shaper,gear,gamma,rp1,rps,thetamin,thetamax,theta1min,theta1max,m,B,R1,R2,n1,n2,T1f,T2f,T21,T12,phi,psi1,psi2,theta1,z1,eqns,guess},
gear = gearset[[1]];
shaper=gear[[1]];
pinion = gearset[[2]];
gamma=gearset[[3]];
rp1=pinion[[1]];
rps=shaper[[1]];
{thetamin,thetamax}=FGInvoluteParameterLimits[shaper];
{theta1min,theta1max}=FGInvoluteParameterLimits[pinion];
m=gear[[3]];
B=rps-rp1;
T1f = Function[{phi},
Composition[RotationTransform[phi,ZAxis],TranslationTransform[{0,-B,0}],RotationTransform[gamma,XAxis]]
];
T2f = Function[{phi},
RotationTransform[phi,ZAxis]
];
T21 = Function[{phi1,phi2},
Composition[T2f[phi2], InverseFunction[T1f[phi1]]]
];
T12 = Function[{phi1,phi2},
Composition[T1f[phi1], InverseFunction[T2f[phi2]]]
];
R2 = FGGearSurfaceFunction[gear];
R1 = FGPinionSurfaceFunction[pinion];
n1=Function[{theta,z},Evaluate@Normalize@Cross[D[R1[theta,z],theta],D[R1[theta,z],z]]];
n2=Function[{theta,phi},Evaluate@Normalize@Cross[D[R2[theta,phi],theta],D[R2[theta,phi],phi]]];
eqns=Function[{theta},
Evaluate@Join[
Thread[R2[theta,phi]==T21[psi1,psi2][R1[theta1,z1]]],
Part[Thread[n2[theta,phi]==T21[psi1,psi2][n1[theta1,z1]]],{1,2}] 
]
];
guess=N[{{phi,0},{psi1,0},{psi2,0},{z1,rp1/m},{theta1,theta1max/2}}];
Monitor[
Table[
R2[theta,phi]/.FindRoot[eqns[theta],guess],
{theta,thetamin,thetamax,(thetamax-thetamin)/20}],
ProgressIndicator[N[theta],{N[thetamin],N[thetamax]}]
]
]


FGTransmissionAnalysis[gearset_Gearset] :=
Module[ {pinion,shaper,gear,gamma,rp1,rps,thetamin,thetamax,theta1min,theta1max,m,B,R1,R2,n1,n2,T1f,T2f,T21,T12,phi,psi1,psi2,theta1,z1,eqns,guess},
gear = gearset[[1]];
shaper=gear[[1]];
pinion = gearset[[2]];
gamma=gearset[[3]];
rp1=pinion[[1]];
rps=shaper[[1]];
{thetamin,thetamax}=FGInvoluteParameterLimits[shaper];
{theta1min,theta1max}=FGInvoluteParameterLimits[pinion];
m=gear[[3]];
B=rps-rp1;
T1f = Function[{phi},
Composition[RotationTransform[phi,ZAxis],TranslationTransform[{0,-B,0}],RotationTransform[gamma,XAxis]]
];
T2f = Function[{phi},
RotationTransform[phi,ZAxis]
];
T21 = Function[{phi1,phi2},
Composition[T2f[phi2], InverseFunction[T1f[phi1]]]
];
T12 = Function[{phi1,phi2},
Composition[T1f[phi1], InverseFunction[T2f[phi2]]]
];
R2 = FGGearSurfaceFunction[gear];
R1 = FGPinionSurfaceFunction[pinion];
n1=Function[{theta,z},Evaluate@Normalize@Cross[D[R1[theta,z],theta],D[R1[theta,z],z]]];
n2=Function[{theta,phi},Evaluate@Normalize@Cross[D[R2[theta,phi],theta],D[R2[theta,phi],phi]]];
eqns=Function[{theta},
Evaluate@Join[
Thread[R2[theta,phi]==T21[psi1,psi2][R1[theta1,z1]]],
Part[Thread[n2[theta,phi]==T21[psi1,psi2][n1[theta1,z1]]],{1,2}] 
]
];
guess=N[{{phi,0},{psi1,0},{psi2,0},{z1,rp1/m},{theta1,theta1max/2}}];
Monitor[
Table[
{psi1,psi2-m*psi1}/.FindRoot[eqns[theta],guess],
{theta,thetamin,thetamax,(thetamax-thetamin)/20}],
ProgressIndicator[N[theta],{N[thetamin],N[thetamax]}]
]
]
